##############################################################################
#    TCL Developer Studio
#
#    Copyright (C) 1999  Alexey Kakunin
#    small@star.spb.ru
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
##############################################################################

proc printDialog { fileName} {
    global printDialog
    global tclDevData
    
    set w [toplevel .printDialog -borderwidth 10]
    wm title $w "Print File:"
    
    if {[info exist tclDevData(positions,printDialog)] &&
             [string range $tclDevData(positions,printDialog) 0 2] != "1x1"} {
        wm geometry $w $tclDevData(positions,printDialog)
    } else {
        set x [expr {([winfo screenwidth .] - 100)/2}]
        set y [expr {([winfo screenheight .] - 100)/2}]
        
        wm geometry $w +$x+$y
    }
    wm protocol $w WM_DELETE_WINDOW "set tclDevData(positions,printDialog) [wm geometry $w];set printDialog(ok) 0"
    
    set printDialog(fileName) $fileName
    append printDialog(fileName) ".ps"
    set printDialog(printerName) $tclDevData(options,defaultPrinter)
    
    set f [frame $w.f]
    pack $f -side left -expand 1 -fill both -padx 3

    set printDialog(there) "printer"
    
    radiobutton $f.toPrinter -text "To Printer:" -variable printDialog(there) -value "printer"
    pack $f.toPrinter -side top -expand 1 -anchor w -pady 2
    tixLabelEntry $f.printer -label "Printer Name:" \
        -options {
            entry.textVariable printDialog(printerName)
            label.width 21
    }
    pack $f.printer -side top -fill x -anchor w -padx 10 -pady 2
    radiobutton $f.toFile -text "To File:" -variable printDialog(there) -value "file"
    pack $f.toFile -side top -expand 1 -anchor w -pady 2
    tixFileEntry $f.file -label "File Name:" \
            -dialogtype tixExFileSelectDialog \
            -options {
                label.width 21 
                entry.textVariable printDialog(fileName) 
            }
    pack $f.file -side top -fill x -anchor w -padx 10 -pady 2
    
    set buttons [tixButtonBox $w.buttons -orientation vertical -pady 2 -relief flat]
    
    $buttons add find -text Print -command {set printDialog(ok) 1}
    $buttons add cancel -text Cancel -command {set printDialog(ok) 0}
    pack $buttons -fill y -expand 1 -side right -padx 3
    
    # run dialog
    tkwait visibility $w
#    focus [$f.findStr subwidget entry]
    grab $w
    tkwait variable printDialog(ok)
    grab release $w
    
    # store position
    set tclDevData(positions,printDialog) [wm geometry $w]
    
    destroy $w
    
    set options {}
    
    if {$printDialog(ok)} {
        lappend result $printDialog(there)
        
        if {$printDialog(there) == "printer"} {
            lappend result $printDialog(printerName)
        } else  {
            lappend result $printDialog(fileName)
        }
        
        return $result
    } else {
        return {}
    }
}
