#!/bin/sh
# Call wish\
exec wish "$0" "$@"

##############################################################################
#    TCL Developer Studio
#
#    Copyright (C) 1999  Alexey Kakunin
#    small@star.spb.ru
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
##############################################################################

if { [file type $argv0] == "link" } {
    set TCLDEV_HOME [file dirname [file readlink $argv0]]
} else {
    set TCLDEV_HOME [file dirname $argv0]
}

# load tix library
package require -exact Tix 4.1.8.0

# set keywords
set tclDevData(keywords) [info commands]

# init global variables
set version 0.25

set tclDevData(files) {}
set tclDevData(curFile) ""
set tclDevData(find) {}
set tclDevData(find,lastOptions) ""
set tclDevData(replace) {}
set tclDevData(projectFile) ""
set tclDevData(menuImages) {}


source [file join $TCLDEV_HOME balloon.tcl]

# create titlepane
source [file join $TCLDEV_HOME titlepan.tcl]
titlePane::show

# load files
source [file join $TCLDEV_HOME images.tcl]

source [file join $TCLDEV_HOME mainfram.tcl]
source [file join $TCLDEV_HOME projwin.tcl]
source [file join $TCLDEV_HOME editwin.tcl]
source [file join $TCLDEV_HOME outwin.tcl]
source [file join $TCLDEV_HOME project.tcl]
source [file join $TCLDEV_HOME help.tcl]
source [file join $TCLDEV_HOME status.tcl]
source [file join $TCLDEV_HOME find.tcl]
source [file join $TCLDEV_HOME options.tcl]
source [file join $TCLDEV_HOME new.tcl]
source [file join $TCLDEV_HOME undo.tcl]
source [file join $TCLDEV_HOME utils.tcl]
source [file join $TCLDEV_HOME print.tcl]

#read options
options::read

# start TCL Developer Studio
mainFrame::create

if {$argc == 1} {
    #open file
    mainFrame::openFile [ConvertPathFromView [lindex $argv 0]]
}




















































































##TCLDevStudioProject
## Attention! Followed data is TCL Developer Studio Project information.
## All data from it place to TCLDevStudioProject_END will removed and rewritted during edition in TCLDevStudio.
## Do not edit it yourself!
#global tclDevData
#set tclDevData(project,version) 2
#set tclDevData(project,both,Name) "TCL Developer Studio"
#set tclDevData(project,unix,Name) ""
#set tclDevData(project,windows,Name) ""
#set tclDevData(project,both,Dir) ""
#set tclDevData(project,unix,Dir) "~/work/tcldev/tcldev-devel"
#set tclDevData(project,windows,Dir) "w:/tcl/tcldev"
#set tclDevData(project,both,RunCmd) ""
#set tclDevData(project,unix,RunCmd) "wish tcldev.tcl"
#set tclDevData(project,windows,RunCmd) "c:/tcl/bin/wish80.exe tcldev.tcl"
#set tclDevData(project,both,DebugCmd) ""
#set tclDevData(project,unix,DebugCmd) ""
#set tclDevData(project,windows,DebugCmd) ""
#set tclDevData(project,both,FileComment) ""
#set tclDevData(project,unix,FileComment) ""
#set tclDevData(project,windows,FileComment) ""
##TCLDevStudioProject_END
