##############################################################################
#    TCL Developer Studio
#
#    Copyright (C) 1999  Alexey Kakunin
#    small@star.spb.ru
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
##############################################################################

# formats string
# insert \ before {}[]""\ 
proc FormatString {text} {
    set l [string length $text]
    
    set result ""
    for {set i 0} {$i < $l} {incr i} {
        set char [string index $text $i]
        set nextChar [string index $text [expr {$i+1}]]
        
        if {$char == "\n"} {
            append result "\\n"
        } else  {
            if {$char == "\{" ||
                $char == "\}" ||
                $char == "\[" ||
                $char == "\]" ||
                $char == "\"" ||
                $char == "\\"} {
                #insert \ before symbol
                append result "\\"
            }
            
            append result $char
        }
    }
    
    return $result
}

proc ConvertPathToView {path} {
    global tcl_platform
    
    if {$tcl_platform(platform) == "windows"} {
        # convert all \ to /
        regsub -all -- "/" $path "\\" result
        return $result
    } else  {
        return $path
    }
}

proc ConvertPathFromView {path} {
    global tcl_platform
    
    if {$tcl_platform(platform) == "windows"} {
        # convert all \ to /

        regsub -all -- "\\\\" $path "/" result
                
        return $result
    } else  {
        return $path
    }
}